###################################################
### chunk number 1: width
###################################################
#line 50 "d:/Rcompile/CRANpkg/local/2.12/intervals/inst/doc/intervals_overview.Rnw"
options( width = 80 )


###################################################
### chunk number 2: Intervals
###################################################
#line 83 "d:/Rcompile/CRANpkg/local/2.12/intervals/inst/doc/intervals_overview.Rnw"
library( intervals )
x <- Intervals( matrix( 1:6, ncol = 2 ) )
x
x[2,2] <- NA
x[3,1] <- 6
x


###################################################
### chunk number 3: Intervals_full
###################################################
#line 99 "d:/Rcompile/CRANpkg/local/2.12/intervals/inst/doc/intervals_overview.Rnw"
y <- as( x, "Intervals_full" )
y <- c( y, Intervals_full( c(2,3,5,7) ) )
closed(y)[2:3,1] <- FALSE
closed(y)[4,2] <- FALSE
rownames(y) <- letters[1:5]
y


###################################################
### chunk number 4: size
###################################################
#line 116 "d:/Rcompile/CRANpkg/local/2.12/intervals/inst/doc/intervals_overview.Rnw"
size(x)
empty(x)
empty(y)


###################################################
### chunk number 5: plotting
###################################################
#line 125 "d:/Rcompile/CRANpkg/local/2.12/intervals/inst/doc/intervals_overview.Rnw"
plot( y )


###################################################
### chunk number 6: set_operations
###################################################
#line 166 "d:/Rcompile/CRANpkg/local/2.12/intervals/inst/doc/intervals_overview.Rnw"
reduce( y )
interval_intersection( x, x + 2 )
interval_complement( x )


###################################################
### chunk number 7: set_operations
###################################################
#line 177 "d:/Rcompile/CRANpkg/local/2.12/intervals/inst/doc/intervals_overview.Rnw"
interval_union( x, interval_complement( x ) )


###################################################
### chunk number 8: distance
###################################################
#line 190 "d:/Rcompile/CRANpkg/local/2.12/intervals/inst/doc/intervals_overview.Rnw"
B <- 100000
left <- runif( B, 0, 1e8 )
right <- left + rexp( B, rate = 1/10 )
v <- Intervals( cbind( left, right ) )
head( v )
mean( size( v ) )
dim( reduce( v ) )
system.time( d <- distance_to_nearest( sample( 1e8, B ), v ) )


###################################################
### chunk number 9: distanceplot
###################################################
#line 204 "d:/Rcompile/CRANpkg/local/2.12/intervals/inst/doc/intervals_overview.Rnw"
hist( d, main = "Distance to nearest interval" )


###################################################
### chunk number 10: overlap
###################################################
#line 231 "d:/Rcompile/CRANpkg/local/2.12/intervals/inst/doc/intervals_overview.Rnw"
rownames(v) <- sprintf( "%06i", 1:nrow(v) )
io <- interval_overlap( v, v )
head( io, n = 3 )
n <- sapply( io, length )
sum( n > 1 )
k <- which.max( n )
io[ k ]
v[ k, ]
v[ io[[ k ]], ]


###################################################
### chunk number 11: clusters
###################################################
#line 255 "d:/Rcompile/CRANpkg/local/2.12/intervals/inst/doc/intervals_overview.Rnw"
B <- 100
left <- runif( B, 0, 1e4 )
right <- left + rexp( B, rate = 1/10 )
y <- reduce( Intervals( cbind( left, right ) ) )
w <- 100
c2 <- clusters( y, w )
c2[1:3]


###################################################
### chunk number 12: expand
###################################################
#line 303 "d:/Rcompile/CRANpkg/local/2.12/intervals/inst/doc/intervals_overview.Rnw"
delta <- .Machine[[ "double.eps" ]]^0.5
y1 <- Intervals( c( .5, 1 - delta / 2 ) )
y2 <- Intervals( c( .25, 1, .75, 2 ) )
y1
y2
all.equal( y1[1,2], y2[2,1] )
interval_intersection( y1, y2 )


###################################################
### chunk number 13: expand
###################################################
#line 326 "d:/Rcompile/CRANpkg/local/2.12/intervals/inst/doc/intervals_overview.Rnw"
contract( y1, delta, "relative" )


###################################################
### chunk number 14: expand
###################################################
#line 333 "d:/Rcompile/CRANpkg/local/2.12/intervals/inst/doc/intervals_overview.Rnw"
inner <- interval_intersection(
                               contract( y1, delta, "relative" ),
                               contract( y2, delta, "relative" )
                               )
inner
outer <- interval_intersection(
                               expand( y1, delta, "relative" ),
                               expand( y2, delta, "relative" )
                               )
outer


###################################################
### chunk number 15: expand
###################################################
#line 351 "d:/Rcompile/CRANpkg/local/2.12/intervals/inst/doc/intervals_overview.Rnw"
interval_difference( outer, inner )


###################################################
### chunk number 16: gaps
###################################################
#line 359 "d:/Rcompile/CRANpkg/local/2.12/intervals/inst/doc/intervals_overview.Rnw"
x <- Intervals( c(1,10,100,8,50,200), type = "Z" )
x
w <- 2
close_intervals( contract( reduce( expand(x, w/2) ), w/2 ) )


###################################################
### chunk number 17: integer_range
###################################################
#line 382 "d:/Rcompile/CRANpkg/local/2.12/intervals/inst/doc/intervals_overview.Rnw"
.Machine$integer.max
numeric_max <- with( .Machine, double.base^double.digits )
options( digits = ceiling( log10( numeric_max ) ) )
numeric_max


###################################################
### chunk number 18: sessionInfo
###################################################
#line 446 "d:/Rcompile/CRANpkg/local/2.12/intervals/inst/doc/intervals_overview.Rnw"
si <- as.character( toLatex( sessionInfo() ) )
cat( si[ -grep( "Locale", si ) ], sep = "\n" )


